 /* Audible Attiny45 Flood Sensor
 
 This sketch will play Super Mario Theme, when water (anything conductive) bridges the gap in the sensor.
 Sketch also tries to save as much power as possible to run off supercapacitors and a small solar cell.
   
   created 28/09/14
   by Non-ICE 

 */
#include "pitches.h"
 
//power management
#include <avr/sleep.h>
#include <avr/wdt.h>
#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif


 int melody[] PROGMEM = {
  NOTE_E7, NOTE_E7, 0, NOTE_E7, 
  0, NOTE_C7, NOTE_E7, 0,
  NOTE_G7, 0, 0,  0,
  NOTE_G6, 0, 0, 0, 

  NOTE_C7, 0, 0, NOTE_G6, 
  0, 0, NOTE_E6, 0, 
  0, NOTE_A6, 0, NOTE_B6, 
  0, NOTE_AS6, NOTE_A6, 0, 

  NOTE_G6, NOTE_E7, NOTE_G7, 
  NOTE_A7, 0, NOTE_F7, NOTE_G7, 
  0, NOTE_E7, 0,NOTE_C7, 
  NOTE_D7, NOTE_B6, 0, 0,

  NOTE_C7, 0, 0, NOTE_G6, 
  0, 0, NOTE_E6, 0, 
  0, NOTE_A6, 0, NOTE_B6, 
  0, NOTE_AS6, NOTE_A6, 0, 

  NOTE_G6, NOTE_E7, NOTE_G7, 
  NOTE_A7, 0, NOTE_F7, NOTE_G7, 
  0, NOTE_E7, 0,NOTE_C7, 
  NOTE_D7, NOTE_B6, 0, 0
};
   
   
 int noteDurations[] PROGMEM = {
  12, 12, 12, 12, 
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12, 

  12, 12, 12, 12,
  12, 12, 12, 12, 
  12, 12, 12, 12, 
  12, 12, 12, 12, 

  9, 9, 9,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,

  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,

  9, 9, 9,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
};

//for sleep mode watchdog timer
volatile boolean f_wdt = 1;
   
   
 const int floodSensors = 2;     // the number of the Flood Sensor pin
 //const int voltpin = 1;     // voltage sensor pin
 //const int drainpin = 4;     // current drain pin (LED)
 //const int drainpin1 = 3;     // current drain pin (LED)
 const int spkPin =  0;      // the number of the speakerpin
 const int wakeskips = 8;    //number of times not to read state when waking from sleep
 // variables will change:
 int floodSensorState = 0;         // variable for reading the floodSensors status
 int wakecounter=9;

 void setup() {
   // initialize the LED pin as an output:
   pinMode(spkPin, OUTPUT);  
   //pinMode(drainpin, OUTPUT);
   //pinMode(drainpin1, OUTPUT);
   // initialize the flood Sensor pin as an input:
   pinMode(floodSensors, INPUT);  

   setup_watchdog(9); // approximately 8 seconds sleep   
 }

 void loop(){
   
   if (f_wdt==1) {  // wait for timed out watchdog / flag is set when a watchdog timeout occurs
     f_wdt=0;       // reset flag
   }

   wakecounter++;
   if (wakecounter >= wakeskips) {
     wakecounter=0;
        
     // read the state of the flood Sensor value:
     floodSensorState = digitalRead(floodSensors);
  
     // check if the flood Sensor is wet.
     // if it is, the floodSensorState is HIGH:
     if (floodSensorState == LOW) {     
       // turn LED on:    now play some funky music!
       //digitalWrite(spkPin, LOW);  
                for (int thisNote = 0; thisNote < 80; thisNote++) {
                /* stolen code alert!
                to calculate the note duration, take one second divided by the note type.
                e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
                */
                int noteDuration = 1000 / pgm_read_word_near(noteDurations + thisNote);
                tone(spkPin, pgm_read_word_near(melody + thisNote), noteDuration);
            
                // to distinguish the notes, set a minimum time between them.
                // the note's duration + 30% seems to work well:
                int pauseBetweenNotes = noteDuration * 1.30;
                //digitalWrite(spkPin,LOW);
                delay(pauseBetweenNotes);
                // stop the tone playing:
                noTone(spkPin);
              }
              digitalWrite(spkPin,LOW);
     }    
   }   
   
   //put system to sleep
   pinMode(spkPin,INPUT); // set all used port to intput to save power
   system_sleep();
   pinMode(spkPin,OUTPUT); // set all ports into state before sleep
   
 }
 
 // set system into the sleep state
// system wakes up when wtchdog is timed out
void system_sleep() {
cbi(ADCSRA,ADEN);                    // switch Analog to Digitalconverter OFF
 
set_sleep_mode(SLEEP_MODE_PWR_DOWN); // sleep mode is set here
sleep_enable();
 
sleep_cpu();                        // System sleeps here
 
sleep_disable();                     // System continues execution here when watchdog timed out
sbi(ADCSRA,ADEN);                    // switch Analog to Digitalconverter ON
}
 
// 0=16ms, 1=32ms,2=64ms,3=128ms,4=250ms,5=500ms
// 6=1 sec,7=2 sec, 8=4 sec, 9= 8sec
void setup_watchdog(int ii) {
 
byte bb;
int ww;
if (ii > 9 ) ii=9;
bb=ii & 7;
if (ii > 7) bb|= (1<<5);
bb|= (1<<WDCE);
ww=bb;
 
MCUSR &= ~(1<<WDRF);
// start timed sequence
WDTCR |= (1<<WDCE) | (1<<WDE);
// set new watchdog timeout value
WDTCR = bb;
WDTCR |= _BV(WDIE);
}
 
// Watchdog Interrupt Service / is executed when watchdog timed out
ISR(WDT_vect) {
f_wdt=1;  // set global flag
}

long readVcc() {
  // Read 1.1V reference against AVcc
  // set the reference to Vcc and the measurement to the internal 1.1V reference
  #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
    ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
    ADMUX = _BV(MUX5) | _BV(MUX0);
  #elif defined (__AVR_ATtiny25__) || defined(__AVR_ATtiny45__) || defined(__AVR_ATtiny85__)
    ADMUX = _BV(MUX3) | _BV(MUX2);
  #else
    ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #endif  
 
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA,ADSC)); // measuring
 
  uint8_t low  = ADCL; // must read ADCL first - it then locks ADCH  
  uint8_t high = ADCH; // unlocks both
 
  long result = (high<<8) | low;
 
  result = 1125300L / result; // Calculate Vcc (in mV); 1125300 = 1.1*1023*1000
  return result; // Vcc in millivolts
}
